!
!  *****************************************
!
!        Ôgʂ̌vZiGaussianj
!      for the Benchmark of Carrier,1991
!
!                   last modified 09/14/2017
!                coded by Y. Shigihara (NDA)
!
!  *****************************************
!
program initgaussian
implicit none
!integer, parameter :: dp = kind(1.0e0)  !single precision
integer, parameter  :: dp = kind(1.0d0)   ! double precision
integer  :: j, k
integer  :: je, ke                        ! iq
real(dp) :: dx                            ! iq(m)
real(dp) :: a                             ! Gaussz̃p[^
real(dp) :: xx, yy, r1, r2
character:: cnx*10
real(dp), allocatable :: z(:,:)
!
open(01,file='initialprofile.txt',status='unknown')


! ********* Parameter Settings *********
je = 1001
ke = 1001
dx = 2000.0d0
a  = 20.0d0*1000.0d0   ! 20*1000 [m] for Case1, 80*1000 [m] for Case2
! **************************************

allocate(z(je,ke))

! ݒ̈̒SGaussz̒_v悤ɔzu
do k=1,ke
    do j=1,je
        xx = dble(je/2+1-j)*dx
        yy = dble(ke/2+1-k)*dx
        r1 = xx*xx + yy*yy
        r2 = r1/(a*a)
        z(j,k)= 2.0d0*exp(-r2) !GaussžvZ
    end do
end do


write(cnx,'(i10)') je
write(01,'('//cnx//'f8.4)')((z(j,k),j=1,je),k=1,je) !ʂ̏o

end program initgaussian
