% Fig.2
% Carrier1991͉ƐliBoussinesq modelj
% Ԕg`̔r̃XNvg
%
%                          17/09/14 National Defense Academy
clear variables

%f[^̕\͈
xstart =  400.0;
xend   =  800.0;
ystart = -0.1;
yend   =  0.11;

%tHgTCY̐ݒ
FontS1 = 12;
FontS2 = 14;
LineW  = 2;

L_sim1 = 'none';
L_sim2 = 'none';
L_ana  = '-';
C_sim1 = 'b';
C_sim2 = 'r';
C_ana  = 'k';
M_ana  = 'none';
M_sim1 = '.';
M_sim2 = '.';
MS_ana = 1;
MS_sim1= 8;
MS_sim2= 8;

% t@CwDpX܂ށD
filenameA = '.\analyticalsolution_case1a20t3600.txt'; %Case1͉̉
filenameB = '.\numericalsolution_boussi090.out';  %̌vZ
filenameC = '.\numericalsolution_boussi45.out';   %45x̌vZ

% t@C̓ǍD
csa = dlmread(filenameA);
anax=csa(:,1);
anay=csa(:,2);

csb = dlmread(filenameB);
simx1=csb(:,1)/1000;
simy1=csb(:,2);

csc = dlmread(filenameC);
simx2=csc(:,1)/1000;
simy2=csc(:,2);

% %}ʂ̕`

figure('Position',[50 50 700 300]) %,'Color','w')

z1 = plot(anax,anay,simx1,simy1,simx2,simy2); 
set(z1,{'LineStyle'},{L_ana;L_sim1;L_sim2},...
       {'LineWidth'},{LineW;LineW;LineW},...
       {'Color'},{C_ana;C_sim1;C_sim2},...
       {'Marker'},{M_ana;M_sim1;M_sim2},...
       {'MarkerSize'},{MS_ana;MS_sim1;MS_sim2})
       
grid on

axis([xstart xend ystart yend])
set(gca,'FontSize',FontS2)
xlabel('Distance [km]')
ylabel('Sea surface elevation [m]')
title('Case1: Analytical Solution vs Boussinesq Model')

%摜̕ۑ
set(gcf,'PaperPositionMode','auto')                                        % gcf:}̃vpeB, 'auto':ʂ̕\TCYŕۑ
print('fig2','-dpng','-r0')
% print('fig2','-depsc','-r0')  % '-r0':ʂ̉𑜓xŕۑ
